Loading...
Searching...
No Matches
CurvatureStencil< GridT, RealT > Class Template Reference

`#include <nanovdb/util/Stencils.h>`

Inheritance diagram for CurvatureStencil< GridT, RealT >:

## Public Types

using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | ValueType = typename GridT::ValueType
using | AccessorType

## Public Member Functions

| CurvatureStencil (const GridType &grid)
| CurvatureStencil (const GridType &grid, double dx)
ValueType | meanCurvature () const
| Return the mean curvature at the previously buffered location.
ValueType | gaussianCurvature () const
| Return the Gaussian curvature at the previously buffered location.
void | curvatures (ValueType &mean, ValueType &gauss) const
| Return both the mean and the Gaussian curvature at the previously buffered location.
ValueType | meanCurvatureNormGrad () const
ValueType | gaussianCurvatureNormGrad () const
void | curvaturesNormGrad (ValueType &mean, ValueType &gauss) const
| Return both the mean and the Gaussian curvature at the previously buffered location.
void | principalCurvatures (ValueType &min, ValueType &max) const
| Computes the minimum and maximum principal curvature at the previously buffered location.
ValueType | laplacian () const
Vec3< ValueType > | gradient () const
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Member Functions

static int | size ()
| Return the size of the stencil buffer.

## Static Public Attributes

static constexpr int | SIZE = 19

## Protected Attributes

const GridType * | mGrid
Coord | mCenter

## Friends

template<typename, int, typename>
class | BaseStencil

## Member Typedef Documentation

## AccessorType

using AccessorType

inherited

## GridType

template<typename GridT, typename RealT = typename GridT::ValueType>

using GridType = GridT

## TreeType

template<typename GridT, typename RealT = typename GridT::ValueType>

using TreeType = typename GridT::TreeType

## ValueType

template<typename GridT, typename RealT = typename GridT::ValueType>

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## CurvatureStencil() [1/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

CurvatureStencil | ( | const GridType & | grid | ) |

inline

## CurvatureStencil() [2/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

CurvatureStencil | ( | const GridType & | grid,
|  | double | dx )

inline

## Member Function Documentation

## accessor()

const AccessorType & accessor | ( |  | ) | const

inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## curvatures()

template<typename GridT, typename RealT = typename GridT::ValueType>

void curvatures | ( | ValueType & | mean,
|  | ValueType & | gauss ) const

inline

Return both the mean and the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## curvaturesNormGrad()

template<typename GridT, typename RealT = typename GridT::ValueType>

void curvaturesNormGrad | ( | ValueType & | mean,
|  | ValueType & | gauss ) const

inline

Return both the mean and the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## gaussianCurvature()

template<typename GridT, typename RealT = typename GridT::ValueType>

ValueType gaussianCurvature | ( |  | ) | const

inline

Return the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## gaussianCurvatureNormGrad()

template<typename GridT, typename RealT = typename GridT::ValueType>

ValueType gaussianCurvatureNormGrad | ( |  | ) | const

inline

Return the mean Gaussian multiplied by the norm of the central-difference gradient.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## getCenterCoord()

const Coord & getCenterCoord | ( |  | ) | const

inline inherited

Return the coordinates of the center point of the stencil.

## getCenterValue()

const ValueType & getCenterValue | ( |  | ) | const

inline inherited

Return the value at the center of the stencil.

## getValue()

const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const

inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## gradient()

template<typename GridT, typename RealT = typename GridT::ValueType>

Vec3< ValueType > gradient | ( |  | ) | const

inline

Return the gradient computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## grid()

const GridType & grid | ( |  | ) | const

inline inherited

Return a const reference to the grid from which this stencil was constructed.

## intersectionMask()

Mask intersectionMask | ( | ValueType | isoValue = ValueType(0) | ) | const

inline inherited

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## intersects()

bool intersects | ( | const ValueType & | isoValue = ValueType(0) | ) | const

inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## laplacian()

template<typename GridT, typename RealT = typename GridT::ValueType>

ValueType laplacian | ( |  | ) | const

inline

Return the Laplacian computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## max()

ValueType max | ( |  | ) | const

inline inherited

Return the largest value in the stencil buffer.

## mean()

ValueType mean | ( |  | ) | const

inline inherited

Return the mean value of the current stencil.

## meanCurvature()

template<typename GridT, typename RealT = typename GridT::ValueType>

ValueType meanCurvature | ( |  | ) | const

inline

Return the mean curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## meanCurvatureNormGrad()

template<typename GridT, typename RealT = typename GridT::ValueType>

ValueType meanCurvatureNormGrad | ( |  | ) | const

inline

Return the mean curvature multiplied by the norm of the central-difference gradient. This method is very useful for mean-curvature flow of level sets!

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## min()

ValueType min | ( |  | ) | const

inline inherited

Return the smallest value in the stencil buffer.

## moveTo()

void moveTo | ( | const Coord & | ijk | ) |

inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## pos()

template<typename GridT, typename RealT = typename GridT::ValueType>
template<int i, int j, int k>

unsigned int pos | ( |  | ) | const

inline

Return linear offset for the specified stencil point relative to its center.

## principalCurvatures()

template<typename GridT, typename RealT = typename GridT::ValueType>

void principalCurvatures | ( | ValueType & | min,
|  | ValueType & | max ) const

inline

Computes the minimum and maximum principal curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## setValue()

void setValue | ( | const ValueType & | value | ) |

inline inherited

Set the value at the specified location relative to the center of the stencil.

## size()

int size | ( |  | ) |

inline static inherited

Return the size of the stencil buffer.

## Friends And Related Symbol Documentation

## BaseStencil

template<typename GridT, typename RealT = typename GridT::ValueType>
template<typename, int, typename>

friend class BaseStencil

friend

## Member Data Documentation

## mCenter

Coord mCenter

protected inherited

## mGrid

const GridType* mGrid

protected inherited

## SIZE

template<typename GridT, typename RealT = typename GridT::ValueType>

int SIZE = 19

static constexpr